# Copyright 2023 Goodwill of Central and Northern Arizona
#
# Licensed under the BSD 3-Clause (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#   https://opensource.org/licenses/BSD-3-Clause
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

from unittest import TestCase

from questionary import ValidationError

from ec2connect.util.validators import instance_validator


class ValidatorsTestCase(TestCase):
    def test_instance_validator(self):
        result = instance_validator([])
        assert isinstance(result, ValidationError)
        assert result.message == "Please select at least one instance"

        result = instance_validator(["one choice"])
        assert result is True
